//////////////////////////////////////////////////////////////////////////////////
//
//
//   File : licqserver.cpp
//
//   Created : 20-March-01
//
//   Description : This is the server that handles AntigoneICQ clients chatting
//                 using Antigone 2.0 system.  It prints out messages sent from
//                 AntigoneICQ clients.
//                    
//   Usage:        licqserver <Group Addr> <Group Port> <Server Port>
//
//   *** Change History ***
//
//   20-March-01 Created File : HL
//
//////////////////////////////////////////////////////////////////////////////////
#include <stdlib.h>
#include <AGroup.h>

int main (int argc, char **argv) { // usage: simple [ host_name_of_server ]
  if (getenv ("NAME") == NULL) putenv ("NAME=unknown"); // set up id

  if(argc!=4){
    cout << "Usage: licqserver <Group Addr> <Group Port> <Server Port>" << endl;
    exit(1);
  }

  ATransport::SetLoopback (TRUE); // set transport policy to loopback
  AGroup *group;
  IPAddress *groupIp; // old values are "224.1.1.27", 9000
  IPAddress *serverIp; // old values are "141.213.74.21", 9001
  String locPol="loc.apd"; //default to "loc.apd" 
  String grpPol="g1.apd"; //default to "g1.apd"
  String polList=""; //default to ""
  ATransport *transport;

  unsigned short antGroupPort=(unsigned short)atoi(argv[2]);
  // Setup the transport layer address - multicast address and port
  groupIp = IPAddress::IPAddressFactory(argv[1], antGroupPort);

  unsigned short antServerPort=(unsigned short)atoi(argv[3]);
  // specify server and port (argv[1] is the host name of the server)
  serverIp = IPAddress::IPAddressFactory(argv[1], antServerPort);

  // Construct transport layer
  transport = new ATransport(groupIp, serverIp->Port(),
			     ATransport::AT_SYMMETRIC);
  // server constructor for group - 5 parameters
  cout << "-1" << endl;
  group = new AGroup(transport, grpPol, locPol, polList, NULL);
  cout << "0" << endl; 
  (void)group->Connect();
  
  // Set up a buffer and send it 
  Buffer *buf=NULL;
  char data='\0';
  unsigned long sender_uin;
  unsigned long flag;
  int times;
  //memset(data,0,1024);
  
  while(true) { cout << "1" << endl;
    //AtkTimer timer(2*1000); timer.reset();   // wait for up to 2 seconds
    //cout << "passed through while loop once" << endl;
    //times=0;
    while(group->readMessage(&buf, (struct timeval*)(NULL))) {
    cout << "2" << endl;
    //while (group->readMessage(&buf, &timer) {  // read messages from group
      if(buf != NULL)
	{
	  Buffer *msg=new Buffer();
	  times++;
	  //if(times>1)
	  //cout << "LOOP THROUGH WHILE LOOP TWICE!!!" << endl;
	  (*buf) >> (*msg);
	  cout << "Length of message is " << msg->Length() <<
	    "unsigned long" << sizeof(unsigned long) << endl;
	  *msg >> sender_uin;
	  //*msg >> data;
	  
	  if(msg->Length()==sizeof(unsigned long)+1)
	    {
	      *msg >> data;
	      cout << "Sender Uin: " << sender_uin << "  Message: "
		   << data << endl;
	      delete msg;
	      delete buf;
	    }
	  else if(msg->Length()==2*sizeof(unsigned long))
	    {
	      *msg >> flag;
	      if(flag==1)
		cout << "ANT_JOIN_GROUP Sender is " << sender_uin << endl;
	      else if(flag==2)
		cout << "ANT_REPLY_JOIN Sender is " << sender_uin << endl;
	      else
		cout << "ERROR: received pkt not recognizable" << endl;
	      delete msg;
	      delete buf;
	    }
	  else if(msg->Length()==3*sizeof(unsigned long))
	    {
	      *msg >> flag;
	      unsigned long reply_uin;
	      *msg >> reply_uin;
	      
	      if(flag==3)
		cout << "ANT_QUERY Sender is " << sender_uin
		     << "; querying " << reply_uin << endl;
	      else if(flag==4)
		cout << "ANT_REPLY_QUERY Sender is " << sender_uin
		     << "; replying " << reply_uin << endl;
	      else
		cout << "ERROR: received pkt not recognizable" << endl;
	      delete msg;
	      delete buf;
	    }
	  else
	    cout << "ERROR: received pkt not recognizable" << endl;
	}
    }
  }
  exit (0);
}
